import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:guru_applifecycle_flutter/guru_applifecycle_flutter.dart';
import 'package:guru_applifecycle_flutter/lifecycle/app_lifecycle_callback.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> with AppLifecycleCallback {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    listenApplifecycle();

    // AppStateEventNotifier.startListening();
    // AppStateEventNotifier.appStateStream.listen((event) {
    //   if (kDebugMode) {
    //     print("@@@@$event");
    //     if (Platform.isIOS) {
    //       Fluttertoast.showToast(msg: "appstate=$event", toastLength: Toast.LENGTH_LONG);
    //     } else {
    //       Fluttertoast.showToast(msg: "appstate=$event", toastLength: Toast.LENGTH_LONG);
    //     }
    //   }
    // });
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    // We also handle the message potentially returning null.
    try {
      platformVersion =
          await GuruApplifecycleFlutter.platformVersion ?? 'Unknown platform version';
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Text('Running on: $_platformVersion\n'),
        ),
      ),
    );
  }

  @override
  void dispose() {
    cancelListenApplifecycle();
    super.dispose();
  }

  @override
  void onAppBackground() {
    print("@@@@  background");
    Fluttertoast.showToast(msg: "appstate=background", toastLength: Toast.LENGTH_LONG);
  }

  @override
  void onAppForeground() {
    print("@@@@  foreground");
    Fluttertoast.showToast(msg: "appstate=foreground", toastLength: Toast.LENGTH_LONG);
  }
}
